//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private FastVolume[] cacheFastVolume = null;

        private static FastVolume checkFastVolume = new FastVolume();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public FastVolume FastVolume(bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            return FastVolume(Input, c_am_mode, c_color, c_EMail, c_FILE_TXT, c_fix_period, c_isSend, c_only_summ_show, c_Part_vol, c_play_signal, c_price_range, c_STEP, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public FastVolume FastVolume(Data.IDataSeries input, bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            if (cacheFastVolume != null)
                for (int idx = 0; idx < cacheFastVolume.Length; idx++)
                    if (cacheFastVolume[idx].C_am_mode == c_am_mode && cacheFastVolume[idx].C_color == c_color && cacheFastVolume[idx].C_EMail == c_EMail && cacheFastVolume[idx].C_FILE_TXT == c_FILE_TXT && cacheFastVolume[idx].C_fix_period == c_fix_period && cacheFastVolume[idx].C_isSend == c_isSend && cacheFastVolume[idx].C_only_summ_show == c_only_summ_show && cacheFastVolume[idx].C_Part_vol == c_Part_vol && cacheFastVolume[idx].C_play_signal == c_play_signal && cacheFastVolume[idx].C_price_range == c_price_range && Math.Abs(cacheFastVolume[idx].C_STEP - c_STEP) <= double.Epsilon && cacheFastVolume[idx].C_SUM_vol_limit == c_SUM_vol_limit && cacheFastVolume[idx].C_tick_count == c_tick_count && cacheFastVolume[idx].C_TIME_FROM == c_TIME_FROM && cacheFastVolume[idx].C_TIME_TO == c_TIME_TO && cacheFastVolume[idx].EqualsInput(input))
                        return cacheFastVolume[idx];

            lock (checkFastVolume)
            {
                checkFastVolume.C_am_mode = c_am_mode;
                c_am_mode = checkFastVolume.C_am_mode;
                checkFastVolume.C_color = c_color;
                c_color = checkFastVolume.C_color;
                checkFastVolume.C_EMail = c_EMail;
                c_EMail = checkFastVolume.C_EMail;
                checkFastVolume.C_FILE_TXT = c_FILE_TXT;
                c_FILE_TXT = checkFastVolume.C_FILE_TXT;
                checkFastVolume.C_fix_period = c_fix_period;
                c_fix_period = checkFastVolume.C_fix_period;
                checkFastVolume.C_isSend = c_isSend;
                c_isSend = checkFastVolume.C_isSend;
                checkFastVolume.C_only_summ_show = c_only_summ_show;
                c_only_summ_show = checkFastVolume.C_only_summ_show;
                checkFastVolume.C_Part_vol = c_Part_vol;
                c_Part_vol = checkFastVolume.C_Part_vol;
                checkFastVolume.C_play_signal = c_play_signal;
                c_play_signal = checkFastVolume.C_play_signal;
                checkFastVolume.C_price_range = c_price_range;
                c_price_range = checkFastVolume.C_price_range;
                checkFastVolume.C_STEP = c_STEP;
                c_STEP = checkFastVolume.C_STEP;
                checkFastVolume.C_SUM_vol_limit = c_SUM_vol_limit;
                c_SUM_vol_limit = checkFastVolume.C_SUM_vol_limit;
                checkFastVolume.C_tick_count = c_tick_count;
                c_tick_count = checkFastVolume.C_tick_count;
                checkFastVolume.C_TIME_FROM = c_TIME_FROM;
                c_TIME_FROM = checkFastVolume.C_TIME_FROM;
                checkFastVolume.C_TIME_TO = c_TIME_TO;
                c_TIME_TO = checkFastVolume.C_TIME_TO;

                if (cacheFastVolume != null)
                    for (int idx = 0; idx < cacheFastVolume.Length; idx++)
                        if (cacheFastVolume[idx].C_am_mode == c_am_mode && cacheFastVolume[idx].C_color == c_color && cacheFastVolume[idx].C_EMail == c_EMail && cacheFastVolume[idx].C_FILE_TXT == c_FILE_TXT && cacheFastVolume[idx].C_fix_period == c_fix_period && cacheFastVolume[idx].C_isSend == c_isSend && cacheFastVolume[idx].C_only_summ_show == c_only_summ_show && cacheFastVolume[idx].C_Part_vol == c_Part_vol && cacheFastVolume[idx].C_play_signal == c_play_signal && cacheFastVolume[idx].C_price_range == c_price_range && Math.Abs(cacheFastVolume[idx].C_STEP - c_STEP) <= double.Epsilon && cacheFastVolume[idx].C_SUM_vol_limit == c_SUM_vol_limit && cacheFastVolume[idx].C_tick_count == c_tick_count && cacheFastVolume[idx].C_TIME_FROM == c_TIME_FROM && cacheFastVolume[idx].C_TIME_TO == c_TIME_TO && cacheFastVolume[idx].EqualsInput(input))
                            return cacheFastVolume[idx];

                FastVolume indicator = new FastVolume();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.C_am_mode = c_am_mode;
                indicator.C_color = c_color;
                indicator.C_EMail = c_EMail;
                indicator.C_FILE_TXT = c_FILE_TXT;
                indicator.C_fix_period = c_fix_period;
                indicator.C_isSend = c_isSend;
                indicator.C_only_summ_show = c_only_summ_show;
                indicator.C_Part_vol = c_Part_vol;
                indicator.C_play_signal = c_play_signal;
                indicator.C_price_range = c_price_range;
                indicator.C_STEP = c_STEP;
                indicator.C_SUM_vol_limit = c_SUM_vol_limit;
                indicator.C_tick_count = c_tick_count;
                indicator.C_TIME_FROM = c_TIME_FROM;
                indicator.C_TIME_TO = c_TIME_TO;
                Indicators.Add(indicator);
                indicator.SetUp();

                FastVolume[] tmp = new FastVolume[cacheFastVolume == null ? 1 : cacheFastVolume.Length + 1];
                if (cacheFastVolume != null)
                    cacheFastVolume.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheFastVolume = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.FastVolume FastVolume(bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            return _indicator.FastVolume(Input, c_am_mode, c_color, c_EMail, c_FILE_TXT, c_fix_period, c_isSend, c_only_summ_show, c_Part_vol, c_play_signal, c_price_range, c_STEP, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.FastVolume FastVolume(Data.IDataSeries input, bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            return _indicator.FastVolume(input, c_am_mode, c_color, c_EMail, c_FILE_TXT, c_fix_period, c_isSend, c_only_summ_show, c_Part_vol, c_play_signal, c_price_range, c_STEP, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.FastVolume FastVolume(bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            return _indicator.FastVolume(Input, c_am_mode, c_color, c_EMail, c_FILE_TXT, c_fix_period, c_isSend, c_only_summ_show, c_Part_vol, c_play_signal, c_price_range, c_STEP, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.FastVolume FastVolume(Data.IDataSeries input, bool c_am_mode, Color c_color, string c_EMail, string c_FILE_TXT, int c_fix_period, bool c_isSend, bool c_only_summ_show, int c_Part_vol, bool c_play_signal, int c_price_range, double c_STEP, int c_SUM_vol_limit, int c_tick_count, string c_TIME_FROM, string c_TIME_TO)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.FastVolume(input, c_am_mode, c_color, c_EMail, c_FILE_TXT, c_fix_period, c_isSend, c_only_summ_show, c_Part_vol, c_play_signal, c_price_range, c_STEP, c_SUM_vol_limit, c_tick_count, c_TIME_FROM, c_TIME_TO);
        }
    }
}
#endregion
